diff --git a/src/libcharon/sa/ikev1/tasks/informational.c b/src/libcharon/sa/ikev1/tasks/informational.c
index f89770753..b507a3a4a 100644
--- a/src/libcharon/sa/ikev1/tasks/informational.c
+++ b/src/libcharon/sa/ikev1/tasks/informational.c
@@ -14,6 +14,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "informational.h"
 
 #include <daemon.h>
@@ -118,7 +140,7 @@ METHOD(task_t, process_r, status_t,
 						/* Cisco boxes reject the first message from 4500 */
 						me = this->ike_sa->get_my_host(this->ike_sa);
 						me->set_port(me, charon->socket->get_port(
-														charon->socket, FALSE));
+														charon->socket, SOCKET_FAMILY_BOTH, FALSE));
 						this->ike_sa->set_other_host(this->ike_sa, redirect);
 						status = this->ike_sa->reauth(this->ike_sa);
 						enumerator->destroy(enumerator);
diff --git a/src/libcharon/sa/ikev1/tasks/isakmp_natd.c b/src/libcharon/sa/ikev1/tasks/isakmp_natd.c
index 01bfabf95..a00d20281 100644
--- a/src/libcharon/sa/ikev1/tasks/isakmp_natd.c
+++ b/src/libcharon/sa/ikev1/tasks/isakmp_natd.c
@@ -38,6 +38,28 @@
  * THE SOFTWARE.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "isakmp_natd.h"
 
 #include <string.h>
@@ -104,7 +126,7 @@ static bool force_encap(ike_cfg_t *ike_cfg)
 {
 	if (!ike_cfg->force_encap(ike_cfg))
 	{
-		return charon->kernel->get_features(charon->kernel) &
+		return charon->kernel->get_features(charon->kernel, AF_INET) &
 					KERNEL_REQUIRE_UDP_ENCAPSULATION;
 	}
 	return TRUE;
diff --git a/src/libcharon/sa/ikev2/task_manager_v2.c b/src/libcharon/sa/ikev2/task_manager_v2.c
index f1228ab07..bf5fdf469 100644
--- a/src/libcharon/sa/ikev2/task_manager_v2.c
+++ b/src/libcharon/sa/ikev2/task_manager_v2.c
@@ -15,6 +15,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "task_manager_v2.h"
 
 #include <math.h>
@@ -2365,13 +2387,13 @@ METHOD(task_manager_t, queue_child, void,
 
 	if (args)
 	{
-		task = child_create_create(this->ike_sa, cfg, FALSE, args->src, args->dst);
+		task = child_create_create(this->ike_sa, cfg->get_ref(cfg), FALSE, args->src, args->dst);
 		task->use_reqid(task, args->reqid);
 		task->use_label(task, args->label);
 	}
 	else
 	{
-		task = child_create_create(this->ike_sa, cfg, FALSE, NULL, NULL);
+		task = child_create_create(this->ike_sa, cfg->get_ref(cfg), FALSE, NULL, NULL);
 	}
 	queue_task(this, &task->task);
 }
diff --git a/src/libcharon/sa/ikev2/tasks/child_create.c b/src/libcharon/sa/ikev2/tasks/child_create.c
index 1c0d7cc77..cdf59911f 100644
--- a/src/libcharon/sa/ikev2/tasks/child_create.c
+++ b/src/libcharon/sa/ikev2/tasks/child_create.c
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "child_create.h"
 
 #include <daemon.h>
@@ -869,7 +891,10 @@ static bool build_payloads(private_child_create_t *this, message_t *message)
 			break;
 	}
 
-	features = charon->kernel->get_features(charon->kernel);
+	host_t *my_host = this->ike_sa->get_my_host (this->ike_sa);
+	int family = my_host->get_family (my_host);
+
+	features = charon->kernel->get_features(charon->kernel, family);
 	if (!(features & KERNEL_ESP_V3_TFC))
 	{
 		message->add_notify(message, FALSE, ESP_TFC_PADDING_NOT_SUPPORTED,
diff --git a/src/libcharon/sa/ikev2/tasks/ike_mobike.c b/src/libcharon/sa/ikev2/tasks/ike_mobike.c
index 5cfc72d78..bc82d3ce3 100644
--- a/src/libcharon/sa/ikev2/tasks/ike_mobike.c
+++ b/src/libcharon/sa/ikev2/tasks/ike_mobike.c
@@ -15,6 +15,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "ike_mobike.h"
 
 #include <string.h>
@@ -279,9 +301,9 @@ static void apply_port(host_t *host, host_t *old, uint16_t port, bool local)
 	{
 		port = old->get_port(old);
 	}
-	else if (local && port == charon->socket->get_port(charon->socket, FALSE))
+	else if (local && port == charon->socket->get_port(charon->socket, SOCKET_FAMILY_BOTH, FALSE))
 	{
-		port = charon->socket->get_port(charon->socket, TRUE);
+		port = charon->socket->get_port(charon->socket, SOCKET_FAMILY_BOTH, TRUE);
 	}
 	else if (!local && port == IKEV2_UDP_PORT)
 	{
@@ -327,6 +349,7 @@ METHOD(ike_mobike_t, transmit, bool,
 	switch (charon->socket->supported_families(charon->socket))
 	{
 		case SOCKET_FAMILY_IPV4:
+		case SOCKET_FAMILY_FC:
 			family = AF_INET;
 			break;
 		case SOCKET_FAMILY_IPV6:
diff --git a/src/libcharon/sa/ikev2/tasks/ike_natd.c b/src/libcharon/sa/ikev2/tasks/ike_natd.c
index 72d057e62..8f43a73bc 100644
--- a/src/libcharon/sa/ikev2/tasks/ike_natd.c
+++ b/src/libcharon/sa/ikev2/tasks/ike_natd.c
@@ -15,6 +15,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "ike_natd.h"
 
 #include <string.h>
@@ -91,7 +113,7 @@ static bool force_encap(ike_cfg_t *ike_cfg)
 {
 	if (!ike_cfg->force_encap(ike_cfg))
 	{
-		return charon->kernel->get_features(charon->kernel) &
+		return charon->kernel->get_features(charon->kernel, AF_INET) &
 					KERNEL_REQUIRE_UDP_ENCAPSULATION;
 	}
 	return TRUE;
@@ -108,6 +130,18 @@ static chunk_t generate_natd_hash(private_ike_natd_t *this,
 	uint64_t spi_i, spi_r;
 	uint16_t port;
 
+	// For FC, the port is not a valid comparison point because that port
+	// is not used to make the address tuple.  It is only used as a local host identifier.
+	socket_family_t family = charon->socket->supported_families(charon->socket);
+	if (family != SOCKET_FAMILY_FC)
+	{
+		port = htons(host->get_port(host));
+	}
+	else
+	{
+		port = 0;
+	}
+
 	/* prepare all required chunks */
 	spi_i = ike_sa_id->get_initiator_spi(ike_sa_id);
 	spi_r = ike_sa_id->get_responder_spi(ike_sa_id);
@@ -115,7 +149,6 @@ static chunk_t generate_natd_hash(private_ike_natd_t *this,
 	spi_i_chunk.len = sizeof(spi_i);
 	spi_r_chunk.ptr = (void*)&spi_r;
 	spi_r_chunk.len = sizeof(spi_r);
-	port = htons(host->get_port(host));
 	port_chunk.ptr = (void*)&port;
 	port_chunk.len = sizeof(port);
 	addr_chunk = host->get_address(host);
diff --git a/src/libstrongswan/networking/host.c b/src/libstrongswan/networking/host.c
index f2768dc10..386bfdde3 100644
--- a/src/libstrongswan/networking/host.c
+++ b/src/libstrongswan/networking/host.c
@@ -17,6 +17,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "host.h"
 
 #include <utils/debug.h>
@@ -85,6 +107,7 @@ METHOD(host_t, is_anyaddr, bool,
 	switch (this->address.sa_family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 		{
 			return memeq(zeroes, &(this->address4.sin_addr.s_addr), IPV4_LEN);
 		}
@@ -122,19 +145,23 @@ int host_printf_hook(printf_hook_data_t *data, printf_hook_spec_t *spec,
 		void *address;
 		uint16_t port;
 		int len;
+		int family;
 
 		address = &this->address6.sin6_addr;
 		port = this->address6.sin6_port;
+		family = this->address.sa_family;
 
 		switch (this->address.sa_family)
 		{
 			case AF_INET:
+			case AF_NETLINK:
 				address = &this->address4.sin_addr;
 				port = this->address4.sin_port;
+				family = AF_INET;		// inet_ntop does not recognize AF_NETLINK
 				/* fall */
 			case AF_INET6:
 
-				if (inet_ntop(this->address.sa_family, address,
+				if (inet_ntop(family, address,
 							  buffer, sizeof(buffer)) == NULL)
 				{
 					snprintf(buffer, sizeof(buffer),
@@ -167,6 +194,7 @@ METHOD(host_t, get_address, chunk_t,
 	switch (this->address.sa_family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 		{
 			address.ptr = (char*)&(this->address4.sin_addr.s_addr);
 			address.len = IPV4_LEN;
@@ -198,6 +226,7 @@ METHOD(host_t, get_port, uint16_t,
 	switch (this->address.sa_family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 		{
 			return ntohs(this->address4.sin_port);
 		}
@@ -218,6 +247,7 @@ METHOD(host_t, set_port, void,
 	switch (this->address.sa_family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 		{
 			this->address4.sin_port = htons(port);
 			break;
@@ -259,6 +289,7 @@ static bool ip_equals(private_host_t *this, private_host_t *other)
 	switch (this->address.sa_family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 		{
 			return memeq(&this->address4.sin_addr, &other->address4.sin_addr,
 						 sizeof(this->address4.sin_addr));
@@ -287,6 +318,7 @@ static bool equals(private_host_t *this, private_host_t *other)
 	switch (this->address.sa_family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 		{
 			return (this->address4.sin_port == other->address4.sin_port);
 		}
@@ -395,6 +427,7 @@ host_t *host_create_from_string_and_family(char *string, int family,
 			addr.v6.sin6_family = AF_INET6;
 			return host_create_from_sockaddr((sockaddr_t*)&addr);
 		case AF_INET:
+		case AF_NETLINK:
 			if (strchr(string, ':'))
 			{	/* do not try to convert v6 addresses for v4 family */
 				return NULL;
@@ -406,7 +439,7 @@ host_t *host_create_from_string_and_family(char *string, int family,
 				return NULL;
 			}
 			addr.v4.sin_port = htons(port);
-			addr.v4.sin_family = AF_INET;
+			addr.v4.sin_family = family == AF_NETLINK ? AF_NETLINK : AF_INET;
 			return host_create_from_sockaddr((sockaddr_t*)&addr);
 		default:
 			return NULL;
@@ -421,6 +454,11 @@ host_t *host_create_from_string(char *string, uint16_t port)
 	return host_create_from_string_and_family(string, AF_UNSPEC, port);
 }
 
+host_t *host_create_from_string_fc(char *string, uint16_t port)
+{
+	return host_create_from_string_and_family(string, AF_NETLINK, port);
+}
+
 /*
  * Described in header.
  */
@@ -431,6 +469,7 @@ host_t *host_create_from_sockaddr(sockaddr_t *sockaddr)
 	switch (sockaddr->sa_family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 		{
 			memcpy(&this->address4, (struct sockaddr_in*)sockaddr,
 				   sizeof(struct sockaddr_in));
@@ -482,6 +521,7 @@ host_t *host_create_from_chunk(int family, chunk_t address, uint16_t port)
 	switch (family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 			if (address.len < IPV4_LEN)
 			{
 				return NULL;
@@ -516,6 +556,7 @@ host_t *host_create_from_chunk(int family, chunk_t address, uint16_t port)
 	switch (family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 			memcpy(&this->address4.sin_addr.s_addr, address.ptr, address.len);
 			this->address4.sin_port = htons(port);
 			this->socklen = sizeof(struct sockaddr_in);
@@ -665,6 +706,7 @@ host_t *host_create_any(int family)
 	switch (family)
 	{
 		case AF_INET:
+		case AF_NETLINK:
 		{
 			this->socklen = sizeof(struct sockaddr_in);
 			update_sa_len(this);
diff --git a/src/libstrongswan/networking/host.h b/src/libstrongswan/networking/host.h
index 6abd93743..a129ddc67 100644
--- a/src/libstrongswan/networking/host.h
+++ b/src/libstrongswan/networking/host.h
@@ -17,6 +17,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup host host
  * @{ @ingroup networking
@@ -140,6 +162,15 @@ struct host_t {
  */
 host_t *host_create_from_string(char *string, uint16_t port);
 
+/**
+ * Constructor to create a host_t object from an address string and set family to AF_NETLINK.
+ *
+ * @param string		string of an address, such as "152.96.193.130"
+ * @param port			port number
+ * @return				host_t, NULL if string not an address.
+ */
+host_t *host_create_from_string_fc(char *string, uint16_t port);
+
 /**
  * Same as host_create_from_string(), but with the option to enforce a family.
  *
diff --git a/src/libstrongswan/selectors/traffic_selector.c b/src/libstrongswan/selectors/traffic_selector.c
index fe61e3768..6dbcc15e2 100644
--- a/src/libstrongswan/selectors/traffic_selector.c
+++ b/src/libstrongswan/selectors/traffic_selector.c
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include <string.h>
 #include <stdio.h>
 
@@ -28,14 +50,15 @@
 
 #define IPV4_LEN	4
 #define IPV6_LEN	16
-#define TS_IP_LEN(this) ({ ((this)->type == TS_IPV4_ADDR_RANGE) ? IPV4_LEN : IPV6_LEN; })
+#define PORTID_LEN  3
+#define TS_IP_LEN(this) ({ (((this)->type == TS_IPV4_ADDR_RANGE) ? IPV4_LEN : (((this)->type == TS_FC_ADDR_RANGE) ? PORTID_LEN: IPV6_LEN) ); })
 
 #define NON_SUBNET_ADDRESS_RANGE	255
 
-ENUM_BEGIN(ts_type_name, TS_IPV4_ADDR_RANGE, TS_IPV6_ADDR_RANGE,
+ENUM_BEGIN(ts_type_name, TS_IPV4_ADDR_RANGE, TS_SECLABEL,
 	"TS_IPV4_ADDR_RANGE",
-	"TS_IPV6_ADDR_RANGE");
-ENUM_NEXT(ts_type_name, TS_SECLABEL, TS_SECLABEL, TS_IPV6_ADDR_RANGE,
+	"TS_IPV6_ADDR_RANGE",
+	"TS_FC_ADDR_RANGE",
 	"TS_SECLABEL");
 ENUM_END(ts_type_name, TS_SECLABEL);
 
@@ -241,7 +264,7 @@ int traffic_selector_printf_hook(printf_hook_data_t *data,
 	len = TS_IP_LEN(this);
 	memset(from, 0, len);
 	memset(to, 0xFF, len);
-	if (this->dynamic &&
+	if (this->dynamic && (this->type != TS_FC_ADDR_RANGE) &&
 		memeq(this->from, from, len) &&	memeq(this->to, to, len))
 	{
 		written += print_in_hook(data, "dynamic");
@@ -252,6 +275,11 @@ int traffic_selector_printf_hook(printf_hook_data_t *data,
 		{
 			inet_ntop(AF_INET, &this->from, from_str, sizeof(from_str));
 		}
+		else if (this->type == TS_FC_ADDR_RANGE)
+		{
+			written += print_in_hook(data, "%x%x%x..%x%x%x", this->from[0], this->from[1], this->from[2],
+					this->to[0], this->to[1], this->to[2]);
+		}
 		else
 		{
 			inet_ntop(AF_INET6, &this->from, from_str, sizeof(from_str));
@@ -319,6 +347,12 @@ int traffic_selector_printf_hook(printf_hook_data_t *data,
 			{
 				written += print_icmp(data, this->from_port);
 			}
+			else if (this->type == TS_FC_ADDR_RANGE)
+			{
+				written += print_in_hook(data, "%d-%d",
+										 this->from_port, this->to_port);
+
+			}
 			else
 			{
 				serv = getservbyport(htons(this->from_port), serv_proto);
@@ -486,7 +520,8 @@ METHOD(traffic_selector_t, is_host, bool,
 		int family = host->get_family(host);
 
 		if ((family == AF_INET && this->type == TS_IPV4_ADDR_RANGE) ||
-			(family == AF_INET6 && this->type == TS_IPV6_ADDR_RANGE))
+			(family == AF_INET6 && this->type == TS_IPV6_ADDR_RANGE) ||
+			(family == AF_NETLINK && this->type == TS_IPV6_ADDR_RANGE))
 		{
 			addr = host->get_address(host);
 			if (memeq(addr.ptr, this->from, addr.len) &&
@@ -522,8 +557,11 @@ METHOD(traffic_selector_t, is_dynamic, bool,
 METHOD(traffic_selector_t, set_address, void,
 	private_traffic_selector_t *this, host_t *host)
 {
-	this->type = host->get_family(host) == AF_INET ? TS_IPV4_ADDR_RANGE
+	if (this->type != TS_FC_ADDR_RANGE)
+	{
+	   this->type = host->get_family(host) == AF_INET ? TS_IPV4_ADDR_RANGE
 												   : TS_IPV6_ADDR_RANGE;
+    }
 
 	if (host->is_anyaddr(host))
 	{
@@ -536,8 +574,11 @@ METHOD(traffic_selector_t, set_address, void,
 		chunk_t from = host->get_address(host);
 		memcpy(this->from, from.ptr, from.len);
 		memcpy(this->to, from.ptr, from.len);
+		if (this->type != TS_FC_ADDR_RANGE)
+		{
 		this->netbits = from.len * 8;
 	}
+	}
 	this->dynamic = FALSE;
 }
 
@@ -547,6 +588,15 @@ METHOD(traffic_selector_t, is_contained_in, bool,
 	private_traffic_selector_t *subset;
 	bool contained_in = FALSE;
 
+	if (this->type == TS_FC_ADDR_RANGE)
+	{
+		if (equals(this, other))
+		{
+			contained_in = TRUE;
+		}
+		return contained_in;
+	}
+
 	subset = (private_traffic_selector_t*)get_subset(this, other);
 
 	if (subset)
@@ -565,6 +615,7 @@ METHOD(traffic_selector_t, includes, bool,
 {
 	chunk_t addr;
 	int family = host->get_family(host);
+	uint16_t port_index = 0;
 
 	if ((family == AF_INET && this->type == TS_IPV4_ADDR_RANGE) ||
 		(family == AF_INET6 && this->type == TS_IPV6_ADDR_RANGE))
@@ -575,6 +626,13 @@ METHOD(traffic_selector_t, includes, bool,
 				memcmp(this->to, addr.ptr, addr.len) >= 0;
 	}
 
+	if (this->type == TS_FC_ADDR_RANGE)
+	{
+		port_index = host->get_port(host);
+
+		return ((this->from_port == port_index) || (this->to_port == port_index));
+	}
+
 	return FALSE;
 }
 
@@ -889,7 +947,7 @@ static private_traffic_selector_t *traffic_selector_create(uint8_t protocol,
 	private_traffic_selector_t *this;
 
 	/* sanity check */
-	if (type != TS_IPV4_ADDR_RANGE && type != TS_IPV6_ADDR_RANGE)
+	if (type != TS_IPV4_ADDR_RANGE && type != TS_IPV6_ADDR_RANGE && type != TS_FC_ADDR_RANGE)
 	{
 		return NULL;
 	}
@@ -926,3 +984,19 @@ static private_traffic_selector_t *traffic_selector_create(uint8_t protocol,
 	}
 	return this;
 }
+
+traffic_selector_t *traffic_selector_create_from_fcsp2_format(chunk_t start_address, uint16_t start_port,
+												chunk_t end_address, uint16_t end_port)
+{
+	ts_type_t type = TS_FC_ADDR_RANGE;
+	private_traffic_selector_t *this = traffic_selector_create(IPPROTO_RAW, type,
+			start_port, end_port);
+
+	memset(this->from, 0x0, start_address.len);
+	memcpy(this->from, start_address.ptr, start_address.len);
+
+	memset(this->to, 0x0, end_address.len);
+	memcpy(this->to, end_address.ptr, end_address.len);
+
+	return &this->public;
+}
diff --git a/src/libstrongswan/selectors/traffic_selector.h b/src/libstrongswan/selectors/traffic_selector.h
index 367b4fff9..2197246e7 100644
--- a/src/libstrongswan/selectors/traffic_selector.h
+++ b/src/libstrongswan/selectors/traffic_selector.h
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup traffic_selector traffic_selector
  * @{ @ingroup selectors
@@ -53,6 +75,15 @@ enum ts_type_t {
 	 */
 	TS_IPV6_ADDR_RANGE = 8,
 
+	/**
+	 * A range of FC addresses, represented by two three (3)
+	 * octet values.  The first value is the beginning FC address
+	 * (inclusive) and the second value is the ending FC address
+	 * (inclusive). All addresses falling between the two specified
+	 *  addresses are considered to be within the list.
+	 */
+	TS_FC_ADDR_RANGE = 9,
+
 	/**
 	 * A security label.
 	 */
@@ -422,4 +453,22 @@ traffic_selector_t *traffic_selector_create_dynamic(uint8_t protocol,
 int traffic_selector_printf_hook(printf_hook_data_t *data,
 							printf_hook_spec_t *spec, const void *const *args);
 
+/**
+ * Create a new traffic selector using data read from the net.
+ *
+ * There exists a mix of network and host order in the params.
+ * But the parser gives us this data in fcsp format, so we
+ * don't have to convert twice.
+ *
+ * @param start_address	start of address range, network order
+ * @param start_type	starting type of following addresses
+ * @param end_address	end of address range, network order
+ * @param end_rctl		Ending R_CTL
+ * @param start_rctl	Starting R_CTL
+ * @param end_type		ending type of following address
+ * @return				traffic_selector_t object
+ */
+traffic_selector_t *traffic_selector_create_from_fcsp2_format(chunk_t start_address, uint16_t start_port,
+												chunk_t end_address, uint16_t end_port);
+
 #endif /** TRAFFIC_SELECTOR_H_ @}*/
